//  Data Structures with Java by John R. Hubbard
//  Copyright McGraw-Hill, 2001
//  Example 13.10 on page 249
//  Testing the Merge Sort

public class Ex1310
{ public static void main(String[] args)
  { int[] a = { 77, 44, 99, 66, 33, 55, 88, 22 };
    print(a);
    sort(a);
    print(a);
  }
  
  private static void print(int[] a)
  { for (int i=0; i<a.length; i++)
      System.out.print(a[i]+" ");
    System.out.println();
  }
  
  public static void sort(int[] a)
  { // POSTCONDITION: a[0] <= a[1] <= ... <= a[a.length-1];
    if (a.length>1) sort(a,0,a.length);                     // step 1
  }

  private static void sort(int[] a, int k, int n)
  { // PRECONDITIONS: 2 <= n <= k+n <= a.length;
    // POSTCONDITION: a[k] <= a[k+1] <= ... <= a[k+n-1];
    if (n<2) return;             
    sort(a,k,n/2);                              // steps 2 & 3
    sort(a,k+n/2,n-n/2);                             // step 4
    merge(a,k,n);                                    // step 5
  }

  private static void merge(int[] a, int k, int n)
  { // PRECONDITIONS: 1 <= n <= k+n <= a.length;
    //                a[k] <= a[k+1] <= ... <= a[k+n/2-1];
    //                a[k+n/2] <= ... <= a[k+n-1];
    // POSTCONDITION: a[k] <= a[k+1] <= ... <= a[k+n-1];
    int[] temp = new int[n];
    int i=0, lo=k, hi=k+n/2;
    while (lo<k+n/2 && hi<k+n)
      temp[i++] = ( a[lo]<=a[hi] ? a[lo++] : a[hi++] );
      // INVARIANT: temp[0..i] is sorted
    while (lo<k+n/2)
      temp[i++] = a[lo++];
      // INVARIANT: temp[0..i] is sorted
    while (hi<k+n)
      temp[i++] = a[hi++];
      // INVARIANT: temp[0..i] is sorted
    for (i=0; i<n; i++)
      a[k+i] = temp[i];
  }
}
