//  Data Structures with Java by John R. Hubbard
//  Copyright McGraw-Hill, 2001
//  Example 13.12 on page 252
//  Testing the Quick Sort

public class Ex1312
{ public static void main(String[] args)
  { int[] a = { 77, 44, 99, 66, 33, 55, 88, 22 };
    print(a);
    sort(a);
    print(a);
  }
  
  private static void print(int[] a)
  { for (int i=0; i<a.length; i++)
      System.out.print(a[i]+" ");
    System.out.println();
  }
  
  private static void swap(int[] a, int i, int j)
  { if (i == j) return;
    int temp=a[j];
    a[j] = a[i];
    a[i] = temp;
  }

  public static void sort(int[] a)
  { // POSTCONDITION: a[0] <= a[1] <= ... <= a[a.length-1];
    if (a.length>1) sort(a,0,a.length);                    // step Q.S.1
  }
  
  public static void sort(int[] a, int k, int n)
  { // PRECONDITIONS: 0 <= k <= k+n <= a.length;
    // POSTCONDITION: a[k] <= a[k+1] <= ... <= a[k+n-1];
    if (n<2) return;             
    int pivot = a[k];                                      // step Q.P.1
    int i = k;                                   
    int j = k+n;                                    
    while (i < j)                                          // step Q.P.3
    { while (i+1<k+n && a[++i]<pivot) ;                    // step Q.P.4
      while (a[--j]>pivot) ;                               // step Q.P.5
      if (i < j) swap(a,i,j);                              // step Q.P.6
      // INVARIANT: a[p]<=pivot<=a[q] for k<=p=<i<j=<q<k+n // step Q.P.7
    }
    swap(a,k,j);                                           // step Q.P.8
    // INVARIANT: a[p]<=a[j]<=a[q] for k<p<j<q<k+n         // step Q.P.9
    sort(a,k,j-k);                                         // step Q.S.4
    sort(a,j+1,k+n-j-1);                                   // step Q.S.5
  }
}