//  Data Structures with Java by John R. Hubbard
//  Copyright McGraw-Hill, 2001
//  Example 13.14 on page 255
//  Testing the Heap Sort

public class Ex1314
{ public static void main(String[] args)
  { int[] a = { 77, 44, 99, 66, 33, 55, 88, 22 };
    print(a);
    sort(a);
    print(a);
  }
  
  private static void print(int[] a)
  { for (int i=0; i<a.length; i++)
      System.out.print(a[i]+" ");
    System.out.println();
  }
  
  private static void swap(int[] a, int i, int j)
  { if (i == j) return;
    int temp=a[j];
    a[j] = a[i];
    a[i] = temp;
  }

  public static void sort(int[] a)
  { // POSTCONDITION: a[0] <= a[1] <= ... <= a[a.length-1];
    for (int i=a.length/2-1; i>=0; i--)                    // step 1
      heapify(a,i,a.length);                              // step 2
    for (int i=a.length-1; i>0; i--)                      // step 4
    { swap(a,0,i);                                        // step 5
      heapify(a,0,i);                                     // step 7
    }
  }

  private static void heapify(int[] a, int i, int j)
  { int tmp=a[i], k=0;                                    // step 1
    while (2*i+1<j)
    { k=2*i+1;
      if (k+1<j && a[k+1] > a[k]) ++k;  // a[k] is the larger child
      if (tmp>=a[k]) break;                               // step 3
      a[i] = a[k];                                        // step 4
      i = k;                                              // step 5
    }
    a[k] = tmp;                                           // step 7
  }
}
