//  Data Structures with Java by John R. Hubbard
//  Copyright McGraw-Hill, 2001
//  Example 13.18 on page 260
//  Testing the Radix Sort

public class Ex1318
{ public static void main(String[] args)
  { int[] a = { 1599129451, 1218730661, 1033674791, 1821455648,
                2133214002, 2122255555, 1000041000, 2015451202
              };
    print(a);
    sort(a);
    print(a);
  }
  
  private static void print(int[] a)
  { for (int i=0; i<a.length; i++)
      System.out.print(a[i]+" ");
    System.out.println();
  }
  
  private static void swap(int[] a, int i, int j)
  { if (i == j) return;
    int temp=a[j];
    a[j] = a[i];
    a[i] = temp;
  }

  public static final int RADIX=10;
  public static final int WIDTH=10;

  public static void sort(int[] a)
  { // POSTCONDITION: a[0] <= a[1] <= ... <= a[a.length-1];
    for (int d=0; d<WIDTH; d++)                           // step 1
      sort(a,d);                                          // step 2
  }

  private static void sort(int[] a, int d)
  { // POSTCONDITION: a[] is sorted stably on digit d;
    int[] c = new int[RADIX];
    for (int i=0; i<a.length; i++)
      ++c[digit(d,a[i])];  // tally the values in a[p..q]
    for (int j=1; j<RADIX; j++)
      c[j] += c[j-1];  // c[j] == num elts in a[] that are <= j
    int[] tmp = new int[a.length];
    for (int i=a.length-1; i>=0; i--)
      tmp[--c[digit(d,a[i])]] = a[i];
    for (int i=0; i<a.length; i++)
    a[i] = tmp[i];
  }
  
  private static int digit(int d, int x)
  { // e.g., digit(3,1234567890) returns 7;
    return x/(int)Math.pow(10,d)%RADIX;
  }
}