//  Data Structures with Java by John R. Hubbard
//  Copyright McGraw-Hill, 2001
//  Example 13.20 on page 262
//  Testing the Bucket Sort

public class Ex1320
{ public static void main(String[] args)
  { int[] a = { 1599129451, 1218730661, 1033674791, 1821455648,
                2133214002, 2122255555, 1000041000, 2015451202
              };
    print(a);
    sort(a);
    print(a);
  }
  
  private static void print(int[] a)
  { for (int i=0; i<a.length; i++)
      System.out.print(a[i]+" ");
    System.out.println();
  }
  
  public static void sort(int[] a)
  { // POSTCONDITION: a[0] <= a[1] <= ... <= a[a.length-1];
    int min=minimum(a);
    int max=maximum(a);
    int n=a.length;
    Bucket[] bucket = new Bucket[n];                      // step 1
    for (int j=0; j<n; j++)
      bucket[j] = new Bucket();  
    for (int i=0; i<n; i++)                               // step 2
    { int j = n*(a[i]-min)/(max+1-min));
      bucket[j].add(a[j]);                                // step 3
    }
    int i=0;
    for (int j=0; j<n; j++)
    { Bucket bucketj=bucket[j];
      bucketj.sort();                                     // step 4
      for (int k=0; k<bucketj.size(); k++)                // step 5
        a[i++] = bucketj.get(k);
    }
  }
  
  public int minimum(int[] a);  // returns the smallest value in a[]
  public int maximum(int[] a);  // returns the largest value in a[]
}