//  Data Structures with Java by John R. Hubbard
//  Copyright McGraw-Hill, 2001
//  Problem 13.26 on page 273
//  The Quick Sort pivoting on the median of thrtee elements

public class Pr1327
{ public static void main(String[] args)
  { int[] a = { 77, 44, 99, 66, 33, 55, 88, 22 };
    print(a);
    sort(a);
    print(a);
  }
  
  private static void print(int[] a)
  { for (int i=0; i<a.length; i++)
      System.out.print(a[i]+" ");
    System.out.println();
  }
  
  private static void swap(int[] a, int i, int j)
  { if (i == j) return;
    int temp=a[j];
    a[j] = a[i];
    a[i] = temp;
  }

  private static void setMedian(int[] a, int i, int j, int k)
  { // POSTCONDITION: either a[i] <= a[j] <= a[k]
    //                    or a[k] <= a[j] <= a[i]
    //   i.e., a[j] is the median of {a[i],a[j],a[k]}
    if (a[i] <= a[k] && a[k] <= a[j]) swap(a,j,k);
    else if (a[j] <= a[i] && a[i] <= a[k]) swap(a,j,i);
    else if (a[j] <= a[k] && a[k] <= a[i]) swap(a,j,k);
    else if (a[k] <= a[i] && a[i] <= a[j]) swap(a,j,i);
  }

  public static void sort(int[] a)
  { if (a.length>1) sort(a,0,a.length);
  }
  
  public static void sort(int[] a, int k, int n)
  { // PRECONDITIONS: 0 <= k <= k+n <= a.length;
    if (n<2) return;
    setMedian(a,k+n/2,k,k+n-1);  // a[k] = median
    int pivot = a[k];
    int i = k;                                   
    int j = k+n;                                    
    while (i < j)
    { while (i+1<k+n && a[++i]<pivot) ;
      while (a[--j]>pivot) ;
      if (i < j) swap(a,i,j);
    }
    swap(a,k,j);
    sort(a,k,j-k);
    sort(a,j+1,k+n-j-1);
  }

}
